'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAtomInput = require('@s-ui/react-atom-input');

var _reactAtomInput2 = _interopRequireDefault(_reactAtomInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculeDropdownOption';
var CLASS_CHECKBOX = BASE_CLASS + '-checkbox';
var CLASS_TEXT = BASE_CLASS + '-text';
var CLASS_DISABLED = BASE_CLASS + '--disabled';

var MoleculeDropdownOption = function MoleculeDropdownOption(_ref) {
  var _cx;

  var children = _ref.children,
      selected = _ref.selected,
      checkbox = _ref.checkbox,
      disabled = _ref.disabled,
      onClick = _ref.onClick,
      value = _ref.value;

  var className = (0, _classnames2.default)(BASE_CLASS, (_cx = {}, (0, _defineProperty3.default)(_cx, CLASS_CHECKBOX, checkbox), (0, _defineProperty3.default)(_cx, CLASS_DISABLED, disabled), (0, _defineProperty3.default)(_cx, 'is-selected', selected), _cx));

  var handleClick = function handleClick(ev) {
    if (!disabled) onClick(ev, { value: value });
  };

  return _react2.default.createElement(
    'div',
    { className: className, onClick: handleClick },
    checkbox && _react2.default.createElement(_reactAtomInput2.default, { type: 'checkbox', checked: selected, disabled: disabled }),
    _react2.default.createElement(
      'span',
      { className: CLASS_TEXT },
      children
    )
  );
};

MoleculeDropdownOption.displayName = 'MoleculeDropdownOption';

MoleculeDropdownOption.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** option value */
  value: _propTypes2.default.string.isRequired,

  /** Content to be included in the option */
  children: _propTypes2.default.node,

  /** Contains checkbox */
  checkbox: _propTypes2.default.bool,

  /** Is disabled */
  disabled: _propTypes2.default.bool,

  /** onClick callback (ev, {value}) */
  onClick: _propTypes2.default.func,

  /** Is initial selected */
  selected: _propTypes2.default.bool
} : {} : {};

MoleculeDropdownOption.defaultProps = {
  checkbox: false,
  disabled: false,
  onClick: function onClick() {},
  selected: false
};

exports.default = MoleculeDropdownOption;